#pragma once



#include <osg/Notify>
#include <osgDB/FileNameUtils>
#include <osgDB/FileUtils>
#include <osgDB/Registry>
#include <osgDB/ReadFile>
#include <osgDB/WriteFile>
#include <stdlib.h>


class ReaderWriterDist : public osgDB::ReaderWriter
{
public:
	ReaderWriterDist();

	virtual const char* className() const { return "distortion set loader"; };
	Options* prepareReading( ReadResult& result, std::string& fileName, std::ios::openmode& mode, const Options* options ) const;
	Options* prepareWriting( WriteResult& result, const std::string& fileName, std::ios::openmode& mode, const Options* options ) const;
	virtual ReadResult readObject( const std::string& file, const osgDB::ReaderWriter::Options* options) const;
	virtual ReadResult readObject( std::istream& fin, const osgDB::ReaderWriter::Options* options ) const;
    virtual WriteResult writeObject( const osg::Object& object, const std::string& fileName, const osgDB::ReaderWriter::Options* options ) const;
    virtual WriteResult writeObject( const osg::Object& object, std::ostream& fout, const osgDB::ReaderWriter::Options* options ) const;


private:
	std::string extensionToAdd;

	osg::ref_ptr<osgDB::Options> readOptions;
	osg::ref_ptr<osgDB::Options> writeOptions;
	osg::ref_ptr<osgDB::ReaderWriter> rw;
};
